User link syntax (user:login) doesn't work for logins consisting of an email adress

2017-07-14 21:22 - Mischa The Evil
Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version: 4.0.0

Resolution: Fixed Affected version: 3.4.0
Description

From #4179#note-69:

Vu Anh wrote:

Seem it isn't working well with syntax "user:abc@example.com” (Login name contain "@" character)

| am able to confirm this issue. Important to note though, is that the short syntax (@login) works as it should.

I'll attach a patch which adds explicit test coverage for this issue. It showcases what works and, after re-enabling the commented-out

assertions, what currently fails.

Patch and confirmation against source:/trunk@16479 (though it is present on 3.4.1 t00).

Environment:

Environment:
Redmine version 3.4.0.devel@rl6479
Ruby version 2.3.3-p222 (2016-11-21) [x86_64-1inux]
Rails version 4.2.8
Environment production
Database adapter Mysql2
SCM:
Subversion 1.8.8
Git 1.9.1
Filesystem
Redmine plugins:
no plugin installed
Related issues:
Related to Redmine - Feature #4179: Link to user in wiki syntax Closed 2009-11-08
Blocks Redmine - Defect #26507: "attachment:filename" link syntax would not w... Closed
Blocks Redmine - Defect #26892: Link to user in wiki syntax only works when |... Closed

Associated revisions

Revision 17392 - 2018-06-17 07:45 - Jean-Philippe Lang

User link syntax (user:login) doesn't work for logins consisting of an email adress (#26443).

Patch by Marius BALTEANU.

History

#1 - 2017-07-14 21:22 - Mischa The Evil
- Related to Feature #4179: Link to user in wiki syntax added

#2 - 2017-07-15 13:06 - Marius BALTEANU

Thanks Mischa for opening this issue. I've already started work to a fix, but | found another issue (user logins with non alphanumeric characters like
https://www.redmine.org/issues/4179#note-69
https://www.redmine.org/projects/redmine/repository/svn/revisions/16479/entry/trunk

john.smith@foo.bar) on textile formatting and | need more time to fix all these issue. Unfortunately, only next week I'll have the time to continue work
on this.

#3 - 2017-07-24 00:22 - Marius BALTEANU
- File 26443 _fix_user_link_syntax.patch added

The attached patch fixes both issues.

Because | couldn't modify the regex to ignore the emails that starts with "@" or "user:", | chose to use the same logic from markdown formatting also
for textile.

Mischa The Evil, when I've implemented this feature, | didn't take into consideration the format user:"abcd@example.com".
@Jean-Philippe Lang, do you think that it'll be better to use the new method "restore_user_links!" also in the markdown/formatting.rb in order to avoid
the almost duplicated regexes?

#4 - 2017-07-25 09:43 - Go MAEDA

- Target version set to 3.4.3

The patch attached in #26443#note-3 fixes this issue properly on the current trunk and 3.4-stable.
Setting target version to 3.4.3.

#5 - 2017-07-26 00:33 - Go MAEDA

- Blocks Defect #26507: "attachment:filename" link syntax would not work if the file name contains "@" added

#6 - 2017-07-30 18:49 - Jean-Philippe Lang
- Assignee set to Marius BALTEANU

Marius BALTEANU wrote:

@Jean-Philippe Lang, do you think that it'll be better to use the new method "restore_user_links!" also in the markdown/formatting.rb in order to
avoid the almost duplicated regexes?

That would be nice indeed if we can use the same method.

#7 - 2017-08-06 09:45 - Marius BALTEANU
- File 26443 fix_user_link_syntax.patch added
Jean-Philippe Lang wrote:

That would be nice indeed if we can use the same method.

Here it is the new patch. | chose to move all the restore redmine links from markdown to the new method because | do not see any side effect.

I'l add a new patch soon that improves the existing tests in order to be sure that all redmine links work on each text formatting (none, textile,
markdown).

#8 - 2017-08-06 09:46 - Marius BALTEANU
- File deleted (26443 _fix_user_link_syntax.patch)

#9 - 2017-08-06 09:52 - Marius BALTEANU

Attached the correct patch. The previous one has an undesired change.

#10 - 2017-08-06 09:53 - Marius BALTEANU
- File 26443 fix_user_link_syntax.patch added

#11 - 2017-08-06 09:53 - Marius BALTEANU
- File deleted (26443 _fix_user_link_syntax.patch)

#12 - 2017-10-15 13:28 - Marius BALTEANU

Just a technical note: An interesting approach is the html-pipeline used by GitHub which easily allows you to apply different filters or transformations
over the initial html. | like that the implementation looks very clean. Jean-Philippe Lang, do you find this approach interesting for a future
implementation in Redmine? | can work on this, but | want a validation first :)

#13 - 2017-10-15 13:47 - Jean-Philippe Lang
- Target version changed from 3.4.3 to 4.0.0

Changes are rather large, setting target to a major version.

#14 - 2018-04-08 09:20 - Marius BALTEANU
- File deleted (26443 _fix_user_link_syntax.patch)

#15 - 2018-04-08 09:22 - Marius BALTEANU
- File 26443 fix_user_link_syntax.patch added

Updated the patch to apply cleanly against current trunk (r17286).

#16 - 2018-04-08 09:37 - Marius BALTEANU

- Blocks Defect #26892: Link to user in wiki syntax only works when login is written in lower case added

#17 - 2018-06-17 07:47 - Jean-Philippe Lang
- Status changed from Confirmed to Closed

- Resolution set to Fixed
Patch committed, thanks Marius.
Marius BALTEANU wrote:
Just a technical note: An interesting approach is the html-pipeline used by GitHub which easily allows you to apply different filters or

transformations over the initial html. | like that the implementation looks very clean. Jean-Philippe Lang, do you find this approach interesting for
a future implementation in Redmine? | can work on this, but | want a validation first :)

It looks very interesting indeed. That would be nice to see how we could benefit to using it.

Files
0001-Add-test-assertions-showcasing-the-issue.patch 1.81 KB 2017-07-14 Mischa The Evil
26443 _fix_user_link_syntax.patch 7.56 KB 2018-04-08 Marius BALTEANU
